#include "pointers.h"

namespace REFINE_NS{

  class Memory : protected Pointers {
  public:
    Memory(class REFINE *);

    void *smalloc(int n, const char *);
    void sfree(void *);
    void *srealloc(void *, int n, const char *name);

    double *create_1d_double_array(int, int, const char *);
    void destroy_1d_double_array(double *, int);

    char **create_2d_char_array(int, int, const char *);
    void destroy_2d_char_array(char **);
    char **grow_2d_char_array(char **, int, int, const char *);
    
    double **create_2d_double_array(int, int, const char *);
    void destroy_2d_double_array(double **);
    double **grow_2d_double_array(double **, int, int, const char *);
    
    int **create_2d_int_array(int, int, const char *);
    void destroy_2d_int_array(int **);
    int **grow_2d_int_array(int **, int, int, const char *);
    
    double **create_2d_double_array(int, int, int, const char *);
    void destroy_2d_double_array(double **, int);
    
    char ***create_3d_char_array(int, int, int,  const char *);
    void destroy_3d_char_array(char ***);

    double ***create_3d_double_array(int, int, int, const char *);
    void destroy_3d_double_array(double ***);
    double ***grow_3d_double_array(double ***, int, int, int, const char *);
    
    double ***create_3d_double_array(int, int, int, int, const char *);
    void destroy_3d_double_array(double ***, int);
    
    double ***create_3d_double_array(int, int, int, int, int, int, const char *);
    void destroy_3d_double_array(double ***, int, int, int);
    
    int ***create_3d_int_array(int, int, int, const char *);
    void destroy_3d_int_array(int ***);
    
    double ****create_4d_double_array(int, int, int, int, const char *);
    void destroy_4d_double_array(double ****);
  };
}
