/* ----------------------------------------------------------------------
   RefinePro - protein refinement code
   Jian Zhang, jianzha@umich.edu

   See the README file in the top-level RefinePro directory
------------------------------------------------------------------------*/

// Pointers class contains ptrs to master copy of
//   fundamental REINE class ptrs stored in refine.h
// every REFINE class inherits from Pointers to access refine.h ptrs
// these variables are auto-initialized by Pointer class constructor
// *& variables are really pointers to the pointers in refine.h
// & enables them to be accessed directly in any class, e.g. error->warning()

#ifndef POINTERS_H
#define POINTERS_H

#include "refine.h"

namespace REFINE_NS {

  class Pointers {
  public:
    Pointers(REFINE *ptr) :
      refine(ptr),
      memory(ptr->memory),
      error(ptr->error),
      //input(ptr->input),
      //remc(ptr->remc),
      protein(ptr->protein) {}
      virtual ~Pointers() {}
      
  protected:
    REFINE *refine;
    Memory *&memory;
    Error *&error;
    //Input *&input;

    //REMC *&remc;
    Protein *&protein;

  };

}

#endif
