/* ----------------------------------------------------------------------
   RefinePro - protein refinement code
   Jian Zhang, jianzha@umich.edu

   See the README file in the top-level RefinePro directory
------------------------------------------------------------------------*/

#ifndef REFINE_H
#define REFINE_H

#include "stdio.h"

namespace REFINE_NS {
  
  class REFINE {
  public:
    // ptrs to fundamental RefinePro classes
    class Memory *memory;         // memory allocation functions
    class Error *error;           // error handling
    //class Input *input;           // input script processing

    // ptrs to top-level RefinePro-specific classes
    class REMC *remc;          // replica exchange MC simulation
    class Protein *protein;    // protein quantities
    //class Movement *movement;  // MC movement
    
    REFINE(int, char **);
    ~REFINE();

    void create();
    void init();
    void destroy();
  };
}

#endif
